/* 
 * $smu-mark$ 
 * $name: hgetopt.c$ 
 * $author: Salvatore Sanfilippo <antirez@invece.org>$ 
 * $copyright: Copyright (C) 1999 by Salvatore Sanfilippo$ 
 * $license: This software is under GPL version 2 of license$ 
 * $date: Fri Nov  5 11:55:48 MET 1999$ 
 * $rev: 8$ 
 */ 

#include <stdlib.h> /* NULL macro */
#include <stdio.h>

char *hoptarg;	/* option argument or NULL */
int targethost = 0;

int require_arg (char *opt, char **optype)
{
	int index = 0;

	while(optype[index] != NULL)
	{
		if (!strcmp(opt, optype[index]+1))
		{
			if (optype[index][0] == ':')
				return 1;
			else
				return 0;
		}
		index++;
	}

	/* option not found, return val is indifferent */
	return 0;
}

char *hgetopt(char **argv, char **optype)
{
	static char **hargv = NULL;

	if (hargv == NULL)
		hargv = argv;

	while(1)
	{
		char *r;

		targethost = 0;
		hoptarg = NULL;

		if (*hargv == NULL || *(hargv+1) == NULL)
			return NULL; /* EOF */

		r = (++hargv)[0];

		if (hargv[0][0] != '-')
			targethost = 1; /* it is not option not even argument */
		else
			r++; /* skip '-' */

		if ( *(hargv+1) != NULL && (hargv+1)[0][0] != '-' && !targethost && require_arg(r, optype))
		{
			hargv++;
			hoptarg = hargv[0];
		}

		return r;
	}
	return NULL; /* prevent Warning */
}

/* TEST MAIN */
/*
int main(char *argc, char **argv)
{
	char *opt;

	while ((opt = hgetopt(argv)) != NULL)
	{
		if (targethost == 1)
		{
			printf("target host: %s\n", opt);
			continue;
		}

		printf("%s ", opt);
		if (hoptarg)
			printf("%s", hoptarg);
		printf("\n");
	}
	return 0;
}
*/
/* TEST MAIN */
