/* 
 * $smu-mark$ 
 * $name: rtt.c$ 
 * $author: Salvatore Sanfilippo <antirez@invece.org>$ 
 * $copyright: Copyright (C) 1999 by Salvatore Sanfilippo$ 
 * $license: This software is under GPL version 2 of license$ 
 * $date: Fri Nov  5 11:55:49 MET 1999$ 
 * $rev: 3$ 
 */ 

#include <time.h>

#include "hping2.h"
#include "globals.h"

void minavgmax(float ms_delay)
{
	static int avg_counter = 0;

	if (rtt_min == 0 || ms_delay < rtt_min)
		rtt_min = ms_delay;
	if (rtt_max == 0 || ms_delay > rtt_max)
		rtt_max = ms_delay;
	avg_counter++;
	rtt_avg = (rtt_avg*(avg_counter-1)/avg_counter)+(ms_delay/avg_counter);
}

int rtt(int seqnum, float *ms_delay)
{
	long sec_delay, usec_delay;
	int i, tablepos = -1, status;

	for (i=0; i<TABLESIZE; i++)
		if (delaytable[i].seq == seqnum)
		{
			tablepos = i;
			break;
		}

	if (tablepos != -1)
	{
		status = delaytable[tablepos].status;
		delaytable[tablepos].status = S_RECV;
		sec_delay = time(NULL) - delaytable[tablepos].sec;
		usec_delay = get_usec() - delaytable[tablepos].usec;
		*ms_delay = (sec_delay * 1000) + ((float)usec_delay / 1000);
		minavgmax(*ms_delay);
	}
	else
	{
		*ms_delay = 0;	/* not in table.. */
		status = 0;	/* we don't know if it's DUP */
	}

	return status;
}
